REALPATH(3)

NAME
realpath - returns the canonicalized absolute pathname

LIBRARY
libc

SYNOPSIS
#include <sys/param.h>
#include <stdlib.h>
char *
realpath(const char * restrict pathname, char * restrict resolvedname);

DESCRIPTION
The realpath() function resolves all symbolic links, extra “/” characters and references to /./ and /../ in pathname, and copies the resulting absolute pathname into the memory referenced by resolvedname. The resolvedname argument must refer to a buffer capable of storing at least MAXPATHLEN characters, or be NULL.

The realpath() function will resolve both absolute and relative paths and return the absolute pathname corresponding to pathname.

RETURN VALUES
If resolvedname is NULL, it will be allocated and the returned pointer can be deallocated using free(3). The realpath() function returns resolvedname on success. If an error occurs, realpath() returns NULL, and resolvedname was not allocated by realpath(), it will contain the pathname which caused the problem.

ERRORS
The function realpath() may fail and set the external variable errno for any of the errors specified for the library functions chdir(2), close(2), fchdir(2), lstat(2), malloc(3), open(2), readlink(2) and getcwd(3).

SEE ALSO
getcwd(3)

STANDARDS
realpath() first appeared in xpg4.2 and is part of p1003.1-2001.

HISTORY
The realpath() function call first appeared in 4.4BSD. In NetBSD 7.0 the function was updated to accept a NULL pointer for the resolvedname argument.

BUGS
This implementation of realpath() differs slightly from the Solaris implementation. The 4.4BSD version always returns absolute pathnames, whereas the Solaris implementation will, under certain circumstances, return a relative resolvedname when given a relative pathname.